#
# This is the SPEC file for creating binary and source RPMs for the VMs.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2011  Marek Marczykowski <marmarek@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#


Name:		qubes-gpg-split
Version:	2.0.63
Release:	1%{dist}
Summary:	The Qubes service for secure gpg separation

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

BuildRequires: make
BuildRequires: gcc
BuildRequires: pandoc

Requires:	gnupg2
Requires:   zenity


Source0: %{name}-%{version}.tar.gz

%description
The Qubes service for delegating gpg actions to other VM. You can keep keys in
secure (even network isolated) VM and only pass data to it for
signing/decryption.

%package tests
Summary:    Tests for Split GPG
Requires:   %{name}
%if ! 0%{?rhel}
Requires:   python%{python3_pkgversion}-dogtail
%endif
Requires:   xdotool
Requires:   dovecot

%description tests
Helper scripts for Split GPG tests.

%prep
%setup -q

%build
make clean
make build

%install
rm -rf $RPM_BUILD_ROOT
make install-vm-fedora DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir /usr/lib/qubes-gpg-split
/usr/lib/qubes-gpg-split/gpg-server
/usr/bin/qubes-gpg-client
/usr/bin/qubes-gpg-client-wrapper
/usr/bin/qubes-gpg-import-key
/etc/qubes-rpc/qubes.Gpg
/etc/qubes-rpc/qubes.GpgImportKey
/etc/profile.d/qubes-gpg.sh
%dir %attr(0777,root,root) /var/run/qubes-gpg-split
/etc/tmpfiles.d/qubes-gpg-split.conf
%{_mandir}/man1/qubes-gpg-client.1*
%{_mandir}/man1/qubes-gpg-client-wrapper.1*
%{_mandir}/man1/qubes-gpg-import-key.1*

%files tests
/usr/lib/qubes-gpg-split/test_evolution.py*
/usr/lib/qubes-gpg-split/test_thunderbird.py*
/usr/lib/qubes-gpg-split/test_smtpd.py*

%changelog
* Sat Aug 06 2022 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-app-linux-split-gpg

* Sat Aug 06 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - fa04403
- version 2.0.63

* Mon Aug 01 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 67cb2bc
- Force --exit-on-status-write-error

* Mon Aug 01 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ab857f6
- Prevent GnuPG from using a closed file descriptor

* Mon Aug 01 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9d35724
- Force batch mode

* Mon Aug 01 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 3c52800
- Disallow --command-fd

* Fri Jul 29 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 434beb8
- version 2.0.62

* Fri Jul 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 315c171
- Emulate --quiet in terms of -q

* Wed Jul 27 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - cca9708
- version 2.0.61

* Wed Jul 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 26add28
- Allow "qubes-gpg-client --verify - a.sig"

* Wed Jul 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 614cd28
- Check that standard streams are open

* Wed Jul 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - f5d08b7
- Mark received file descriptors CLOEXEC

* Wed Jul 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 529ad8c
- Make is_client a const global variable

* Wed Jul 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 914c2f9
- Refuse to use the same FD for both reading and writing

* Wed Jul 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 8d33d4d
- Use common code for file descriptor lists

* Sun Jul 10 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 54cee94
- Allow exporting public keyring backups

* Sat Jul 09 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - f59430f
- Avoid dropping a trailing empty string

* Sat Jul 09 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 56f8076
- Do not send argv[0] to server

* Sat Jul 09 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 7d59f75
- Fix cast to a potentially-misaligned pointer

* Sat Jul 09 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2a52a8e
- Ensure that argc is never 0

* Sat Jul 09 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 5a936a3
- Avoid UBSAN splat on max-length input

* Sat Jul 09 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6c504d3
- Fix misleading comments

* Thu Jul 07 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 23aa560
- Allow --show-session-key

* Thu Jun 30 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 52a34bc
- Properly NULL-terminate argument list

* Mon Jun 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 15e93bf
- Do not ignore -q and --quiet

* Mon Jun 20 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - df14681
- Allow --export-ownertrust

* Sun Jun 12 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 37139cf
- gpg-client: check for too many file names

* Sun Jun 05 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 3a300ec
- Have bash choose an unused file descriptor

* Sun Jun 05 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 44d6ed0
- Avoid hang due to premature file descriptor close

* Mon May 30 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c5316c9
- version 2.0.60

* Thu May 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 754e16e
- Allow --list-options show-sig-subpackets

* Mon May 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bd743ea
- version 2.0.59

* Mon May 09 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - bd9002a
- .qubesbuilder: replace 'spec' by 'build'

* Mon May 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e5a5a51
- tests: really just sign in test_010_send_receive_signed_only

* Mon May 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f4265a7
- tests: adjust message view in Evolution

* Mon May 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 68cb2d9
- tests: close Evolution settings via xdotool

* Mon May 09 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5d6dfd4
- tests: update Evolution test for newer settings dialog layout

* Fri Apr 29 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 7889084
- Allow show-photos as a list or verify option

* Mon Apr 18 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 5daed1f
- Add Qubes Builder v2 integration

* Fri Apr 15 2022 Frédéric Pierret (fepitre) <frederic.pierret@qubes-os.org> - 18ce4f4
- Drop Travis CI

* Sat Apr 02 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 338d3c4
- version 2.0.58

* Sat Mar 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - c03c30a
- Fix list and verify option processing

* Sat Mar 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - c4a180f
- Drop --pgp2

* Sat Mar 26 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ea7df21
- Reject options ignored by the wrapper script

* Sun Mar 06 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - a652de5
- test: avoid false negative from sending status dialog

* Mon Feb 28 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bd3b0bf
- version 2.0.57

* Sun Feb 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - b5c4aed
- Allow --attribute-fd

* Sun Feb 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 72bab32
- Fix remaining hangs

* Sun Feb 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - b528828
- process_io(): block SIGCHLD

* Sun Feb 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - abcff74
- process_out(): treat an empty FD_SET properly

* Sun Feb 27 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 702461f
- Set empty handler for SIGPIPE

